"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EspruinoTool = void 0;
var uart_ts_1 = require("uart.ts");
var fetchHelper_1 = require("./helpers/fetchHelper");
var EspruinoTool = /** @class */ (function () {
    function EspruinoTool() {
        this.connected = false;
        this.UART = uart_ts_1.uart;
        this.deviceType = undefined;
    }
    EspruinoTool.prototype.dump = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.eval('E.dumpStr();\n')];
            });
        });
    };
    EspruinoTool.prototype.getDeviceType = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.eval("process.env.BOARD;\n")];
            });
        });
    };
    EspruinoTool.prototype.getBattery = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.eval("E.getBattery();\n")];
            });
        });
    };
    EspruinoTool.prototype.getTemperature = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.eval("E.getTemperature();\n")];
            });
        });
    };
    EspruinoTool.prototype.eval = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        _this.UART.eval(code, function (t) {
                            resolve(t);
                        });
                    })];
            });
        });
    };
    EspruinoTool.prototype.write = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        _this.UART.write(code, function () {
                            resolve();
                        });
                    })];
            });
        });
    };
    EspruinoTool.prototype.connect = function (callback) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write('\x03;\n').then(function () {
                            _this.connected = true;
                            _this.UART.write('digitalPulse(LED2,1,100);\n');
                            _this.getDeviceType().then(function (type) {
                                _this.deviceType = type;
                                callback();
                            });
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EspruinoTool.prototype.disconnect = function (callback) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write('digitalPulse(LED1,1,100);\n').then(function () {
                            var _a;
                            (_a = _this.UART) === null || _a === void 0 ? void 0 : _a.close();
                            _this.connected = false;
                            _this.deviceType = undefined;
                            callback();
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EspruinoTool.prototype.reset = function () {
        this.UART.write('reset(true);\n');
    };
    EspruinoTool.prototype.upload = function (url, flash) {
        if (flash === void 0) { flash = false; }
        return __awaiter(this, void 0, void 0, function () {
            var deviceType, success;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getDeviceType()];
                    case 1:
                        deviceType = _a.sent();
                        if (deviceType === 'BANGLEJS') {
                            flash = false;
                        }
                        success = false;
                        return [4 /*yield*/, (0, fetchHelper_1.fetchToText)(url).then(function (rawCode) { return __awaiter(_this, void 0, void 0, function () {
                                var _this = this;
                                return __generator(this, function (_a) {
                                    this.dump().then(function (response) { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            return [2 /*return*/];
                                        });
                                    }); });
                                    this.reset();
                                    if (!flash && !success) {
                                        this.UART.write(rawCode);
                                    }
                                    else if (!success && deviceType !== 'PIXLJS') {
                                        this.UART.write("E.setBootCode(`".concat(rawCode, "`,true);\n"));
                                        this.UART.write('load();\n');
                                    }
                                    else if (!success) {
                                        this.UART.write(rawCode);
                                        this.UART.write('save();\n');
                                        this.UART.write('load();\n');
                                    }
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return EspruinoTool;
}());
exports.EspruinoTool = EspruinoTool;
