export interface IPuck {
    onPress(func: Function): void;
    getTemperature(): Promise<number>;
    LED: LED;
    NFC: NFC;
}
export declare type LEDColoursType = 'red' | 'green' | 'blue';
export declare const LEDColours: string[];
export interface LED {
    on(color: LEDColoursType): void;
    off(color: LEDColoursType): void;
    flash(color: LEDColoursType, ms: number): void;
    val(color: LEDColoursType): Promise<string>;
}
export interface NFC {
    setUrl(url: string): void;
    reset(): void;
}
